From 114c75006862664cc224d94603d294aad3bc18a7 Mon Sep 17 00:00:00 2001
From: Pankaj Yadav <pk@videolan.org>
Date: Sun, 9 Jan 2011 01:27:15 +0530
Subject: [PATCH 3/4] Symbian Specific initialization Routines Including ThreadController

---
 src/symbian/symbian.c |   69 +++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 69 insertions(+), 0 deletions(-)
 create mode 100755 src/symbian/symbian.c

diff --git a/src/symbian/symbian.c b/src/symbian/symbian.c
new file mode 100755
index 0000000..7cf506e
--- /dev/null
+++ b/src/symbian/symbian.c
@@ -0,0 +1,69 @@
+/*****************************************************************************
+ * symbian.cpp: OS-specific initialization
+ *****************************************************************************
+ * Copyright © 2010 Pankaj Yadav
+ * Author: Pankaj Yadav
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
+ *****************************************************************************/
+#include "path.h"
+extern "C"
+{
+#ifdef HAVE_CONFIG_H
+# include "config.h"
+#endif
+
+#include <vlc_common.h>
+#include "../../../../src/libvlc.h"
+#include <pthread.h>
+
+void * ThreadController (void * );
+static vlc_thread_t threadid;
+static int dead=0;
+static int ret;
+
+static void set_libvlc_path (void)
+{
+    char drive[11];const char * letter;
+    letter=GetConstPrivatePath();
+    drive[0]=*letter;
+    drive[1]=':';drive[2]='\\';drive[3]='s';drive[4]='y';
+    drive[5]='s';drive[6]='\\';drive[7]='b';drive[8]='i';
+    drive[9]='n';drive[10]='\0';
+    free(letter);
+    psz_vlcpath = strdup(drive);
+}
+
+void system_Init (libvlc_int_t *libvlc, int *argc, const char *argv[])
+{
+    pthread_once_t once = PTHREAD_ONCE_INIT;
+    ret=pthread_create(&threadid,NULL,ThreadController,&dead);
+    pthread_once (&once, set_libvlc_path);
+    (void)libvlc; (void)argc; (void)argv;
+}
+
+void system_Configure (libvlc_int_t *libvlc,
+                       int argc, const char *const argv[])
+{
+    (void)libvlc; (void)argc; (void)argv;
+}
+
+void system_End (libvlc_int_t *libvlc)
+{
+    dead=1;
+    (void)libvlc;
+}
+
+}/*extern C*/
+
-- 
1.7.1

